package com.zhongzheng.modules.pay.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.course.domain.CourseEducationType;
import com.zhongzheng.modules.user.domain.SchoolProject;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.pay.bo.PayAisleAddBo;
import com.zhongzheng.modules.pay.bo.PayAisleQueryBo;
import com.zhongzheng.modules.pay.bo.PayAisleEditBo;
import com.zhongzheng.modules.pay.domain.PayAisle;
import com.zhongzheng.modules.pay.mapper.PayAisleMapper;
import com.zhongzheng.modules.pay.vo.PayAisleVo;
import com.zhongzheng.modules.pay.service.IPayAisleService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 支付通道Service业务层处理
 *
 * @author ruoyi
 * @date 2021-10-12
 */
@Service
public class PayAisleServiceImpl extends ServiceImpl<PayAisleMapper, PayAisle> implements IPayAisleService {

    @Override
    public PayAisleVo queryById(Long aisleId){
        PayAisle db = this.baseMapper.selectById(aisleId);
        return BeanUtil.toBean(db, PayAisleVo.class);
    }

    @Override
    public List<PayAisleVo> queryList(PayAisleQueryBo bo) {
        LambdaQueryWrapper<PayAisle> lqw = Wrappers.lambdaQuery();
        lqw.eq(StrUtil.isNotBlank(bo.getPayWay()), PayAisle::getPayWay, bo.getPayWay());
        lqw.in(bo.getStatus() != null, PayAisle::getStatus, bo.getStatus());
        lqw.orderByDesc(PayAisle::getUpdateTime);
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<PayAisleVo> entity2Vo(Collection<PayAisle> collection) {
        List<PayAisleVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, PayAisleVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<PayAisle> page = (Page<PayAisle>)collection;
            Page<PayAisleVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(PayAisleAddBo bo) {
        PayAisle add = BeanUtil.toBean(bo, PayAisle.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(PayAisleEditBo bo) {
        PayAisle update = BeanUtil.toBean(bo, PayAisle.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(PayAisle entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
